$MOD51
$TITLE(Heizungsregelung v2.0)
;Unterprogramm status wird im Bsp. nicht benutzt
;Quelltext je nach Assembler anpassen !

	ORG 0000h               ;start nach Reset
	ljmp init

	ORG 0003h
	reti                    ;unben.

	ORG 000Bh
	ljmp int_1  		;Timer0 einsprungaddr.

	ORG 0013h
	reti                    ;unben.

	ORG 001Bh
	reti                    ;unben.

	ORG 0023h
	reti                    ;unben.

	ORG 0030h
int_1: 				;interruptroutine,ca.14mal/sek.
	push acc   		;bei 11 Mhz
	push psw
	djnz r7,L0
	lcall MUX               ;Temperaturwerte holen
	mov r7,#20h
L0:    	pop  psw
	pop  acc
	reti

init:                          	;initialisierungsroutine
	mov p2,#07h		;Relais aus
	mov p1,#255		;ADC-high
	clr p2.6   		;lsb sperren
	clr p2.7   		;msb sperren
	setb p3.0  		;WR-high
	setb p3.2  		;INT-high
	lcall MUX  		;erst mal Daten holen

TMR:
	mov r7,#20h 		;r7 setzen
	mov tmod,#01h 		;timermode 1(16bit)
	setb tr0    		;timer0 starten
	setb et0    		;timer0 int.freigeben
	clr  pt0    		;niedrige ebene
	setb ea     		;allgem.int.freig.

	ljmp SPREG


status:				;schaltet bei zu kleiner kessel-
				;temp.anzeige ab
	clr c
	mov r0,#32h  		;zeiger ks. ist
	mov a,@r0
	subb a,#1Eh  		;festw.1Eh=30C
	jc stat
	sjmp st_end
stat:  	clr c
	setb p2.6    		;lsb freigeben
	mov r1,#00h
	mov r2,#30h
lop4:  	djnz r1,lop4 		;gltig bei 2 Mhz
	djnz r2,lop4 		;Quarzfreq.
	lcall ff
	ajmp status  		;endlosschleife
ff:    	jb 7fh,lop5
	setb p3.1    		;setzen status-LED
	setb 7fh
	mov r1,#00h
lop6:  	djnz r1,lop6 		;zeitschl.
	ret
lop5:  	clr  p3.1    		;loeschen status-LED
	clr 7fh
	mov r1,#00h
lop7:  	djnz r1,lop7 		;zeitschl.
	ret
st_end:	clr p2.6     		;lsb sperren
	ajmp SPREG   		;ende stat,weiter
				;mit SPREG

SPREG: 				;fragt zuerst speicher ab

	lcall DIL  		;
	clr c
	mov r0,#31h		;zeiger auf sp.ist
	mov a,@r0  		;daten holen
	mov r0,#35h		;zeiger auf sp.soll
	subb a,@r0 		;ist-soll
	jnc SPaus
	clr c
	mov r0,#31h		;zeiger auf sp.ist
	mov a,@r0  		;daten holen
	add a,#04h 		;4C add.(Hyst.)
	mov r0,#35h		;zeiger auf sp. soll
	subb a,@r0 		;(ist+4C)-soll
	jc SPein
	ajmp REGLER
SPein: 	ajmp SPREG1
	ret
SPaus: 	ajmp REGLER

SPREG1:				;regelt speicherbeheizung
	lcall DIL
	clr c
	mov r0,#31h		;zeiger sp.ist
	mov a,@r0  		;daten holen
	mov r0,#33h		;zeiger diff.temp.
	add a,@r0  		;diff.temp.add.
	mov r2,a   		;daten ablegen
	mov r0,#32h		;zeiger ks.ist
	mov a,@r0  		;daten holen
	subb a,r2  		;r2 subtr.
	jnc UPein
	clr c
	mov r0,#31h		;zeiger sp.ist
	mov a,@r0  		;daten holen
	add a,#04h 		;4C add.(Hyst.)
	mov r2,a   		;daten ablegen
	mov r0,#32h		;zeiger ks. ist
	mov a,@r0  		;daten holen
	subb a,r2  		;r2 subtr.
	jc UPaus
	ajmp SPREG
UPein: 	setb p2.3
	clr  p2.4
	setb p2.5
	ajmp SPREG
UPaus: 	clr p2.3
	clr p2.4
	clr p2.5
	ajmp SPREG

REGLER:				;regelt Heizung
	lcall DIL
	clr c
	mov r0,#32h		;zeiger ks.ist
	mov a,@r0  		;daten holen
	mov r0,#34h		;zeiger ks.soll
	subb a,@r0 		;kessel ist-soll
	jnc HZein
	mov r0,#32h		;zeiger ks.ist
	mov a,@r0  		;daten holen
	add a,#04h 		;4C add.(Hyst.)
	mov r0,#34h		;zeiger ks.soll
	subb a,@r0 		;(ist+4C)-ks.soll
	jc HZaus
	ajmp SPREG
HZein: 	setb p2.3
	clr  p2.5
	setb p2.4
	ajmp SPREG
HZaus: 	clr p2.4
	clr p2.3
	clr p2.5
	ajmp SPREG

				;steuert ADC und MUX an
MUX:   	clr p3.5
	clr p3.6
	clr p3.7    		;kanal E1,00h
	mov r7,#30h
LP0:   	djnz r7,LP0 		;schleife
	mov r0,#30h 		;zeiger frei
	lcall read
	setb p3.5   		;kanal E2,01h
	mov r7,#30h
LP1:   	djnz r7,LP1 		;schleife
	mov r0,#31h 		;zeiger sp.ist
	lcall read
	clr  p3.5   		;
	setb p3.6   		;kanal E3,02h
	mov r7,#30h
LP2:   	djnz r7,LP2 		;schleife
	mov r0,#32h 		;zeiger ks.ist
	lcall read
	setb p3.5   		;kanal E4,03h
	setb p3.6
	mov r7,#30h
LP3:   	djnz r7,LP3 		;schleife
	mov r0,#33h 		;zeiger diff.t.
	lcall read
	clr  p3.5
	clr  p3.6
	setb p3.7   		;kanal E5,04h
	mov r7,#30h
LP4:   	djnz r7,LP4 		;schleife
	mov r0,#34h 		;zeiger ks.soll
	lcall read
	setb p3.5   		;kanal E6,05h
	clr  p3.6
	setb p3.7
	mov r7,#30h
LP5:   	djnz r7,LP5 		;schleife
	mov r0,#35h 		;zeiger sp.soll
	lcall read
	setb p3.6   		;kanal E7,06h
	mov r7,#30h
LP6:   	djnz r7,LP6 		;schleife
	mov r0,#36h 		;zeiger frei
	lcall read
	setb p3.5   		;kanal E8,07h
	mov r7,#30h
LP7:   	djnz r7,LP7 		;schleife
	mov r0,#37h 		;zeiger frei
	lcall read
	ret

read:  	nop
	mov p1,#255 		;p1 init.vorsorgl.
	clr  p3.0   		;WR-low
	setb p3.0   		;WR-high
wdh:   	jb p3.2,wdh             ;warte bis ADC fertig
	mov @r0,p1   		;RAM laden
	ret
 
				;liest DIL-schalter ein und
				;zeigt gewhlte RAM-zelle an
DIL:   	mov dptr,#LTAB		;zeiger tab.anf.
	clr c
	clr a
	mov c,p2.2    		;p2.2 einlesen
	rlc a
	clr c
	mov c,p2.1    		;p2.1 einlesen
	rlc a
	clr c
	mov c,p2.0    		;p2.0 einlesen
	rlc a
	clr c
	rl a          		;akku x2
	jmp @a+dptr 		;weiter bei A+DPTR
LTAB:  	ajmp LT0    		;sprungtabelle
	ajmp LT1    		;sprungtabelle
	ajmp LT2    		;sprungtabelle
	ajmp LT3    		;sprungtabelle
	ajmp LT4    		;sprungtabelle
	ajmp LT5    		;sprungtabelle
	ajmp LT6    		;sprungtabelle
	ajmp LT7    		;sprungtabelle
LT0:   	mov r0,#30h 		;zeiger frei
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT1:   	mov r0,#31h 		;zeiger sp.ist
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT2:   	mov r0,#32h 		;zeiger ks.ist
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT3:   	mov r0,#33h		;zeiger diff.temp.
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT4:   	mov r0,#34h 		;zeiger ks.soll
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT5:   	mov r0,#35h 		;zeiger sp.soll
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT6:   	mov r0,#36h 		;zeiger frei
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LT7:   	mov r0,#37h 		;zeiger frei
	mov a,@r0
	lcall ANZG  		;anzeigeroutine
	sjmp LGEM
LGEM:  	ret         		;programmende

ANZG:  				;programm fuer multiplexanz.
	lcall UMS
	mov r1,a    		;wieder speichern
	mov p0,a    		;bit 0_3 ausgeben
	setb p2.6   		;lsb aktivieren
	clr  p2.7   		;msb sperren
	mov r0,#40h 		;
lop2:  	djnz r0,lop2		;schleife
	clr  p2.6   		;lsb sperren
	mov a,r1    		;daten holen
	swap a      		;halbbytes vert.
	mov p0,a    		;bit 4_7 ausgeben
	setb p2.7   		;msb aktivieren
	clr  p2.6   		;lsb sperren
	mov r0,#40h 		;
lop3:  	djnz r0,lop3		;schleife
	clr  p2.7   		;msb sperren
	ret

				;umsetzung bin/bcd
UMS:     mov dptr,#LTAB2
         rl a
         jmp @a+dptr
LTAB2:   ajmp LT00
         ajmp LT01
         ajmp LT02
         ajmp LT03
         ajmp LT04
         ajmp LT05
         ajmp LT06
         ajmp LT07
         ajmp LT08
         ajmp LT09
         ajmp LT0A
         ajmp LT0B
	 ajmp LT0C
         ajmp LT0D
         ajmp LT0E
         ajmp LT0F
         ajmp LT10
         ajmp LT11
         ajmp LT12
         ajmp LT13
         ajmp LT14
         ajmp LT15
         ajmp LT16
         ajmp LT17
         ajmp LT18
         ajmp LT19
         ajmp LT1A
         ajmp LT1B
         ajmp LT1C
         ajmp LT1D
         ajmp LT1E
	 ajmp LT1F
         ajmp LT20
         ajmp LT21
         ajmp LT22
         ajmp LT23
         ajmp LT24
         ajmp LT25
         ajmp LT26
         ajmp LT27
         ajmp LT28
         ajmp LT29
         ajmp LT2A
         ajmp LT2B
         ajmp LT2C
         ajmp LT2D
         ajmp LT2E
         ajmp LT2F
         ajmp LT30
         ajmp LT31
	 ajmp LT32
         ajmp LT33
         ajmp LT34
         ajmp LT35
         ajmp LT36
         ajmp LT37
         ajmp LT38
         ajmp LT39
         ajmp LT3A
         ajmp LT3B
         ajmp LT3C
         ajmp LT3D
         ajmp LT3E
         ajmp LT3F
         ajmp LT40
         ajmp LT41
         ajmp LT42
         ajmp LT43
         ajmp LT44
	 ajmp LT45
         ajmp LT46
         ajmp LT47
         ajmp LT48
         ajmp LT49
         ajmp LT4A
         ajmp LT4B
         ajmp LT4C
         ajmp LT4D
         ajmp LT4E
         ajmp LT4F
         ajmp LT50
         ajmp LT51
         ajmp LT52
         ajmp LT53
         ajmp LT54
         ajmp LT55
         ajmp LT56
         ajmp LT57
	 ajmp LT58
         ajmp LT59
         ajmp LT5A
         ajmp LT5B
         ajmp LT5C
         ajmp LT5D
         ajmp LT5E
         ajmp LT5F
         ajmp LT60
         ajmp LT61
         ajmp LT62
         ajmp LT63

				;sprungtabellen
LT00:    mov a,#00h
         ret 
LT01:    mov a,#01h
         ret
LT02:    mov a,#02h
	 ret
LT03:    mov a,#03h
         ret
LT04:    mov a,#04h
         ret
LT05:    mov a,#05h
         ret
LT06:    mov a,#06h
         ret
LT07:    mov a,#07h
         ret
LT08:    mov a,#08h
         ret
LT09:    mov a,#09h
         ret
LT0A:    mov a,#10h
         ret
LT0B:    mov a,#11h
         ret
LT0C:    mov a,#12h
         ret
LT0D:    mov a,#13h
         ret
LT0E:    mov a,#14h
         ret
LT0F:    mov a,#15h
         ret
LT10:    mov a,#16h
         ret
LT11:    mov a,#17h
         ret
LT12:    mov a,#18h
         ret
LT13:    mov a,#19h
         ret
LT14:    mov a,#20h
         ret
LT15:    mov a,#21h
	 ret
LT16:    mov a,#22h
         ret
LT17:    mov a,#23h
         ret
LT18:    mov a,#24h
         ret
LT19:    mov a,#25h
         ret
LT1A:    mov a,#26h
         ret
LT1B:    mov a,#27h
         ret
LT1C:    mov a,#28h
         ret
LT1D:    mov a,#29h
         ret
LT1E:    mov a,#30h
         ret
LT1F:    mov a,#31h
         ret
LT20:    mov a,#32h
         ret
LT21:    mov a,#33h
         ret
LT22:    mov a,#34h
         ret
LT23:    mov a,#35h
         ret
LT24:    mov a,#36h
         ret
LT25:    mov a,#37h
         ret
LT26:    mov a,#38h
         ret
LT27:    mov a,#39h
         ret
LT28:    mov a,#40h
	 ret
LT29:    mov a,#41h
         ret
LT2A:    mov a,#42h
         ret
LT2B:    mov a,#43h
         ret
LT2C:    mov a,#44h
         ret
LT2D:    mov a,#45h
         ret
LT2E:    mov a,#46h
         ret
LT2F:    mov a,#47h
         ret
LT30:    mov a,#48h
         ret
LT31:    mov a,#49h
         ret
LT32:    mov a,#50h
         ret
LT33:    mov a,#51h
         ret
LT34:    mov a,#52h
         ret
LT35:    mov a,#53h
         ret
LT36:    mov a,#54h
         ret
LT37:    mov a,#55h
         ret
LT38:    mov a,#56h
         ret
LT39:    mov a,#57h
         ret
LT3A:    mov a,#58h
         ret
LT3B:    mov a,#59h
         ret
LT3C:    mov a,#60h
         ret
LT3D:    mov a,#61h
         ret
LT3E:    mov a,#62h
         ret
LT3F:    mov a,#63h
         ret
LT40:    mov a,#64h
         ret
LT41:    mov a,#65h
         ret
LT42:    mov a,#66h
         ret
LT43:    mov a,#67h
         ret
LT44:    mov a,#68h
         ret
LT45:    mov a,#69h
         ret
LT46:    mov a,#70h
         ret
LT47:    mov a,#71h
         ret
LT48:    mov a,#72h
         ret
LT49:    mov a,#73h
         ret
LT4A:    mov a,#74h
         ret
LT4B:    mov a,#75h
         ret
LT4C:    mov a,#76h
         ret
LT4D:    mov a,#77h
         ret
LT4E:    mov a,#78h
         ret
LT4F:    mov a,#79h
         ret
LT50:    mov a,#80h
         ret
LT51:    mov a,#81h
         ret
LT52:    mov a,#82h
         ret
LT53:    mov a,#83h
         ret
LT54:    mov a,#84h
         ret
LT55:    mov a,#85h
         ret
LT56:    mov a,#86h
         ret
LT57:    mov a,#87h
         ret
LT58:    mov a,#88h
         ret
LT59:    mov a,#89h
         ret
LT5A:    mov a,#90h
         ret
LT5B:    mov a,#91h
         ret
LT5C:    mov a,#92h
         ret
LT5D:    mov a,#93h
         ret
LT5E:    mov a,#94h
         ret
LT5F:    mov a,#95h
         ret
LT60:    mov a,#96h
         ret
LT61:    mov a,#97h
         ret
LT62:    mov a,#98h
         ret
LT63:    mov a,#99h 		;ALARM !!!
         ret
 
	 end